VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Visualizzatore dati"
   ClientHeight    =   3570
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   6480
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3570
   ScaleWidth      =   6480
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmd_Avanti 
      Caption         =   "Avanti >>"
      Height          =   375
      Left            =   3840
      TabIndex        =   9
      Top             =   2400
      Width           =   1695
   End
   Begin VB.CommandButton cmd_Indietro 
      Caption         =   "<< Indietro"
      Height          =   375
      Left            =   840
      TabIndex        =   8
      Top             =   2400
      Width           =   1695
   End
   Begin VB.CommandButton cmd_Inserisci 
      Caption         =   "Inserisci"
      Height          =   495
      Left            =   4920
      TabIndex        =   7
      Top             =   1200
      Width           =   1335
   End
   Begin VB.CommandButton cmd_Cancella 
      Caption         =   "Cancella"
      Height          =   495
      Left            =   4920
      TabIndex        =   6
      Top             =   360
      Width           =   1335
   End
   Begin VB.Data Data1 
      Caption         =   "Data1"
      Connect         =   "Access"
      DatabaseName    =   ""
      DefaultCursorType=   0  'DefaultCursor
      DefaultType     =   2  'UseODBC
      Exclusive       =   0   'False
      Height          =   375
      Left            =   1320
      Options         =   0
      ReadOnly        =   0   'False
      RecordsetType   =   1  'Dynaset
      RecordSource    =   "SELECT * FROM Persone"
      Top             =   3000
      Visible         =   0   'False
      Width           =   3735
   End
   Begin VB.TextBox txt_DataNascita 
      DataField       =   "Data_nascita"
      DataSource      =   "Data1"
      Height          =   285
      Left            =   600
      TabIndex        =   2
      Top             =   1920
      Width           =   1455
   End
   Begin VB.TextBox txt_Cognome 
      DataField       =   "Cognome"
      DataSource      =   "Data1"
      Height          =   285
      Left            =   600
      TabIndex        =   1
      Top             =   1200
      Width           =   2775
   End
   Begin VB.TextBox txt_Nome 
      DataField       =   "Nome"
      DataSource      =   "Data1"
      Height          =   285
      Left            =   600
      TabIndex        =   0
      Top             =   480
      Width           =   2775
   End
   Begin VB.Label Label3 
      Caption         =   "Data nascita:"
      Height          =   255
      Left            =   600
      TabIndex        =   5
      Top             =   1680
      Width           =   1335
   End
   Begin VB.Label Label2 
      Caption         =   "Cognome:"
      Height          =   255
      Left            =   600
      TabIndex        =   4
      Top             =   960
      Width           =   1335
   End
   Begin VB.Label Label1 
      Caption         =   "Nome:"
      Height          =   255
      Left            =   600
      TabIndex        =   3
      Top             =   240
      Width           =   1335
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' --------------------------------------------------------------------------------------
' A. Veneziani - Programma di editing di un set di dati, tramite operazioni svolte
' con il controllo Data di Visual Basic, in collegamento con DB Microsoft Access
'
' --------------------------------------------------------------------------------------


' tasto per il movimento avanti "collegato" opportunamente  al DataControl
' (operando con il metodo MoveNext)
Private Sub cmd_Avanti_Click()
    ' se e' arrivato all'ultimo record non va' avanti
    If Not Ultimo(Data1.Recordset) Then Data1.Recordset.MoveNext
End Sub

' operazioni di cancellazione dati...
Private Sub cmd_Cancella_Click()
     ' si puo' cancellare se e' almeno un record...
     If Data1.Recordset.RecordCount <> 0 Then Data1.Recordset.Delete         ' cancellazione del record corrente...
     
     ' implementa il movimento successivo
     ' di passaggio:
     ' opzione a) al record precedente....
     If Not Ultimo(Data1.Recordset) Then
         Data1.Recordset.MoveNext
     ' opzione b) se questo non e' possibile al record successivo...
     ElseIf Not Primo(Data1.Recordset) Then
         Data1.Recordset.MovePrevious
     ElseIf Data1.Recordset.RecordCount = 0 Then
     ' opzione c) se non esistono piu' record
     ' ==>  si cancellano comunque i dati delle box, nell'evenienza sia l'ultimo record...
     
         txt_Nome.Text = ""
         txt_Cognome.Text = ""
         txt_DataNascita.Text = ""
     ' altrimenti (opzione d) e' rimasto un solo record...
     End If
End Sub

' tasto per il movimento indietro "collegato" opportunamente  al DataControl
' (operando con il metodo MovePrevious)
Private Sub cmd_Indietro_Click()
    ' se e' al primo record non va' indietro
    If Not Primo(Data1.Recordset) Then Data1.Recordset.MovePrevious
End Sub

' operazioni di inserimento dati...
Private Sub cmd_Inserisci_Click()

    ' se l'inserimento  gi stato attivato...
    If cmd_Inserisci.Caption = "Conferma" Then
         ' effettua aggiornamento recordset...
         Data1.Recordset.Update
         cmd_Inserisci.Caption = "Inserisci"    ' cambia etichetta pulsante...
         RiabilitaAltri
         ' (il record visualizzato dopo l'operazione di update sara' quello
         ' visualizzato prima di tale operazione)
         If Data1.Recordset.RecordCount = 1 Then Data1.Recordset.AbsolutePosition = 1
    Else
    ' se non era stata intrapresa precedentemente una operazione di inserimento...
         Data1.Refresh
         Data1.Recordset.AddNew    ' predispone nuovo recordset in coda
         cmd_Inserisci.Caption = "Conferma"     ' cambia etichetta pulsante...
         DisabilitaAltri
    End If
End Sub

' al caricamento del form...
Private Sub Form_Load()
    ' individua il database Access su cui operare
    Data1.DatabaseName = App.Path & "\db_test.mdb"
End Sub

' routine che controlla se il record corrente e' l'ultimo
' (rende un booleano)
Function Ultimo(Rs As Recordset) As Boolean
    If Rs.RecordCount = 0 Then     ' se non ci sono record...
        Ultimo = True                 ' ...allora e' ultimo...
    Else
        Rs.MoveNext            ' (*) altrimenti e' necessario  spostarsi in avanti
                                    ' (la posizione di EOF si trova oltre il limite dell' ultimo record)
        
        If Rs.EOF Then     ' controlla se siamo in EOF  (possibile solo se eravamo sull' ultimo record)
            Ultimo = True           ' rende  valore booleano opportuno....
        Else
            Ultimo = False
        End If
        Rs.MovePrevious        ' dopo il controllo, effettua l'operazione simmetrica alla (*)
    End If
End Function

' routine che controlla se il record corrente e' il primo
' (rende un booleano)
Function Primo(Rs As Recordset) As Boolean
    If Rs.RecordCount = 0 Then    ' se non ci sono record...
        Primo = True                 ' ...allora e' primo...
    Else
        Rs.MovePrevious           ' (*)  altrimenti e' necessario  spostarsi indietro
                                        ' (la posizione di BOF si trova oltre il limite del primo record)
        
        If Rs.BOF Then       ' controlla se siamo in BOF  (possibile solo se eravamo sul primo record)
            Primo = True           ' rende  valore booleano opportuno....
        Else
            Primo = False
        End If
        Rs.MoveNext               ' dopo il controllo, effettua l'operazione simmetrica alla (*)
    End If
End Function

' routine che disabilita tutti i pulsanti (tranne quello di inserimento)
Sub DisabilitaAltri()
    cmd_Indietro.Enabled = False
    cmd_Avanti.Enabled = False
    cmd_Cancella.Enabled = False
End Sub

' routine che riabilita tutti i pulsanti
Sub RiabilitaAltri()
    cmd_Indietro.Enabled = True
    cmd_Avanti.Enabled = True
    cmd_Cancella.Enabled = True
End Sub

